# NMT: Need Manual Testing - Allows to delay the version job which creates the tag until manually approved
.version:
  stage: version
  image: colisweb/semantic-release:1.0.0
  tags:
    - aws
  script:
    - LAST_TAG=$(git tag --sort=creatordate | tail -1)
    - |
      if ! git log --format=%B ${LAST_TAG}..HEAD | grep "\[NMT\]"
      then
        release $DEFAULT_BRANCH
        test -f version || exit 0 # no new version created
      else
        echo "No version will be generated: an [NMT] flag has been found in the git history since ${LAST_TAG}."
      fi
  rules:
    - !reference [.rules-only-for-default, rules]
  interruptible: true


.update-recette:
  extends:
    - .rules-manual-for-main
  stage: version
  image: $DOCKER_REGISTRY/$BASE_INFRA_IMAGE
  tags:
    - aws
  variables:
    GIT_DEPTH: 50
  script:
    - set -x
    - git config --global user.email $GITLAB_USER_EMAIL
    - git config --global user.name "$GITLAB_USER_NAME"
    - git pull --depth $GIT_DEPTH origin default
    - git checkout default
    - |
      if git fetch --depth $GIT_DEPTH origin recette:recette ; then
        echo "recette branch fetched from origin"
        git checkout recette
        rebase_from_ancestor default
      else
        git checkout -b recette
        echo "recette branch created from default"
      fi
    - git remote set-url origin https://gitlab.ci1:$GITLAB_TOKEN@gitlab.com/${CI_PROJECT_PATH}.git
    - git push origin recette -f
  cache: { }
  interruptible: true

.force-version:
  extends:
    - .version
  stage: check
  script:
    - release
    - test -f version || exit 0 # no new version created
  allow_failure: true
  rules:
    - !reference [ .rules-schedule-reference, rules ]
    - if: '$CI_COMMIT_BRANCH == $DEFAULT_BRANCH'
      when: manual


.notify-new-version:
  after_script:
    - !reference [.before_template, import_functions]
    - if [[ "$ENVIRONMENT" = "production" || "$CI_JOB_STATUS" != "success" ]] ; then notify_new_version Deployment ; fi
